"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GeolocationTagNames = void 0;
exports.isGeolocationTag = isGeolocationTag;
const Object_1 = require("./Object");
exports.GeolocationTagNames = (0, Object_1.keysOf)({
    GeolocationBearing: true,
    GeolocationCity: true,
    GeolocationCountry: true,
    GeolocationCountryCode: true,
    GeolocationDistance: true,
    GeolocationFeatureCode: true,
    GeolocationFeatureType: true,
    GeolocationPopulation: true,
    GeolocationPosition: true,
    GeolocationRegion: true,
    GeolocationSubregion: true,
    GeolocationTimeZone: true,
    GeolocationWarning: true,
});
/**
 * Is the given tag name intrinsic to the content of a given file? In other
 * words, is it not an artifact of a metadata field?
 */
function isGeolocationTag(name) {
    return exports.GeolocationTagNames.includes(name);
}
//# sourceMappingURL=GeolocationTags.js.map